#ifndef TAPE_H_INCLUDED
#define TAPE_H_INCLUDED

#include "pc6001v.h"
#include "device.h"
#include "ini.h"
#include "p6t2.h"
#include "sound.h"

#include "p6device.h"


// f[^̎
#define PG_P	(0x0000)
#define PG_S	(0x0100)
#define PG_D	(0x0200)


////////////////////////////////////////////////////////////////
// NX`
////////////////////////////////////////////////////////////////
class CMTL : public P6DEVENT, public Device, public SndDev, public IDoko {
private:
	char FilePath[PATH_MAX];	// TAPEt@CtpX
	cP6T *p6t;
	BOOL Relay;					// [̏
	
	BOOL Boost;					// BoostUpg? TRUE:g FALSE:gȂ
	int MaxBoost60;				// BoostUp ő{(N60[h)
	int MaxBoost62;				// BoostUp ő{(N60m/N66[h)
	
	BOOL Remote( BOOL );			// [g(PLAY,STOP)
	WORD CmtRead();					// CMT 1Ǎ
	int GetSinCurve( int );			// sing擾
	
	int GetSampleRate();			// TvO[g擾
	
	// foCX`
	static const Descriptor descriptor;
	static const InFuncPtr  indef[];
	static const OutFuncPtr outdef[];
	const Descriptor* GetDesc() const { return &descriptor; }
	
	// I/OANZX֐
	inline void OutB0H( int, BYTE data ){ Remote( data&0x08 ? TRUE : FALSE ); }
	
public:
	CMTL( VM6 *, const ID& );		// RXgN^
	virtual ~CMTL();				// fXgN^
	
	void EventCallback( int, int );	// CxgR[obN֐
	
	BOOL Init();					// 
	void Reset();					// Zbg
	
	void SetAutoStart( int );		// I[gX^[gݒ
	
	BOOL Mount( char * );			// TAPE }Eg
	void Unmount();					// TAPE A}Eg
	
	WORD Update();					// Xg[XV
//	void SoundUpdate( int );		// ŏIIɂ͂̌`ɂ
	
	BOOL IsMount();					// }Egς?
	BOOL IsAutoStart();				// I[gX^[g?
	
	char *GetFile();				// t@CpX擾
	char *GetName();				// TAPE擾
	DWORD GetSize();				// x^C[WTCY擾
	int GetCount();					// JE^擾
	BOOL IsRelay();					// [̏Ԏ擾
	
	void SetBoost( BOOL );			// BoostUpݒ
	void SetMaxBoost( int, int );	// BoostUpő{ݒ
	BOOL IsBoostUp();				// BoostUpԎ擾
	
	// foCXID
	enum IDOut{ outB0H=0 };
	enum IDIn {};
	
	// ------------------------------------------
	BOOL DokoSave( cIni * );		// ǂłSAVE
	BOOL DokoLoad( cIni * );		// ǂłLOAD
	// ------------------------------------------
};


class CMTS : public P6DEVENT {
private:
	char FilePath[PATH_MAX];		// TAPEt@CtpX
	
	FILE *fp;						// FILE |C^
	int Baud;						// {[[g
	
public:
	CMTS( VM6 *, const P6ID& );		// RXgN^
	~CMTS();						// fXgN^
	
//	BOOL Init();					// 
	BOOL Init( char * );			// 
	
//	BOOL Mount( char * );			// TAPE }Eg
	BOOL Mount();					// TAPE }Eg
	void Unmount();					// TAPE A}Eg
	
	void SetBaud( int );			// {[[gݒ
	
	void CmtWrite( BYTE );			// CMT 1
};


#endif	// TAPE_H_INCLUDED
